<? 
  #  This program is free software; you can redistribute it and/or modify
  #  it under the terms of the GNU General Public License version 2 as 
  #  published by the Free Software Foundation.
  #
  #  This program is distributed in the hope that it will be useful,
  #  but WITHOUT ANY WARRANTY; without even the implied warranty of
  #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #  GNU General Public License for more details.
  #
  #  You should have received a copy of the GNU General Public License
  #  along with this program; if not, write to the Free Software
  #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  # $Id: ce_classes.inc,v 2.7 2009-11-24 01:17:28 peter Exp $

# handle display_item_cnt in own function to avoid global variable
# this cannot be done inside a class function because there are
# different classes and they do not share static variables
function ce_display_item_cnt()
{
  static $display_item_cnt=1;
  return $display_item_cnt++;
}

class ce_item 
{
   var $id;
   var $path;
   var $state;
   var $data;
   var $locale;
   var $name;
   var $author;
   var $content_type;
   var $date_created;
   var $last_modified;
   var $layout_class;

   var $layout_ref;
   var $content_ref;

   var $mysql_result;

   var $display_item_no;

   var $edit_link_shown;

   function cleardata()
     {
       $id            = NULL;
       $path          = NULL;
       $state         = NULL;
       $data          = NULL;
       $last_modified = NULL;
       $locale        = NULL;
       $name          = NULL;
       $author        = NULL;
       $content_type  = NULL;
       $date_created  = NULL;
       $last_modified = NULL;
       $layout_class  = NULL;
       $layout_ref    = NULL;
       $content_ref   = NULL;
       # mysql_result is not cleared on purpose!
     }

   function get_content_name()
     {
       if( isset($this->content_ref ) )
         return $this->content_ref->get_content_name();
       else
         return $this->name ;
     }

   function get_content_abstract()
     {
       if( isset($this->content_ref ) )
         return $this->content_ref->get_content_abstract();
       else
         return $this->abstract ;
     }

   function get_content_date_created()
     {
       if( isset($this->content_ref ) )
         return $this->content_ref->get_content_date_created();
       else
         return $this->date_created ;
     }

   function get_content_last_modified()
     {
       if( isset($this->content_ref ) )
         return $this->content_ref->get_content_last_modified();
       else
         return $this->last_modified ;
     }

   function get_content_author()
     {
       if( isset($this->content_ref ) )
         return $this->content_ref->get_content_author();
       else
         return $this->author ;
     }

   # function &get_last_content_ref()
   #   {
   #     if( isset($this->content_ref ) )
   #       return $this->content_ref->get_last_content_ref();
   #     else
   #       return $this ;
   #   }

   function mysql_fetch()
     {
       if( $mysql_row = mysql_fetch_array($this->mysql_result) )
         {
           $this->cleardata(); # being paranoid;
           $this->id           = $mysql_row["id"];
           $this->state        = $mysql_row["state"];
           $this->name         = $mysql_row["name"];
           $this->path         = $mysql_row["path"];
           $this->author       = $mysql_row["author"];
           $this->abstract     = $mysql_row["abstract"];
           $this->content_type = $mysql_row["content_type"];
           $this->data         = $mysql_row["data"];
           $this->locale       = $mysql_row["locale"];
           $this->date_created = $mysql_row["date_created"];
           $this->last_modified= $mysql_row["date_modified"];
           $this->layout_ref = NULL;
           $this->content_ref = NULL;
           
           $tmp_layout_path=$mysql_row["layout_path"];
           if( "." == substr($this->layout_class,0,1) )
             $tmp_layout_path=$tmp_layout_path.$this->layout_class;
           elseif( "/" == substr($this->layout_class,-1,1) )
             $tmp_layout_path=$this->layout_class.$tmp_layout_path;
           elseif( !empty($this->layout_class) )
             $tmp_layout_path=$this->layout_class;

           if( !empty($tmp_layout_path) )
             {
               $this->layout_ref =& new ce_item($tmp_layout_path);
               if($this->layout_ref->id != NULL)
                 { ce_debug(7,"\n<!-- found layout '"
                            .$tmp_layout_path
                            ."'  in ce_item-&gt;mysql_fetch() -->",
                            __FILE__,__LINE__);
                   $this->layout_ref->content_ref =& $this; }
               else
                 { ce_debug(7,"\n<!-- no layout '"
                            .$tmp_layout_path
                            ."' found in ce_item-&gt;mysql_fetch() -->",
                            __FILE__,__LINE__);
                   if(isset($this->content_ref))
                     ce_warn("Layout $tmp_layout_path not found",$this);
                   $this->layout_ref = NULL; }
             }
           unset($tmp_layout_path);
           return true;
         }
       else
         {
           mysql_free_result($this->mysql_result);
           $this->cleardata();
           return false;
         }
     }

   function display_item_no()
     {
       empty($this->display_item_no) && $this->display_item_no=ce_display_item_cnt();
       return $this->display_item_no;
     }

   function display_item_no_spent()
     {
       unset($this->display_item_no);
     }

   function ce_item($path=NULL,$layout_class="",$state=NULL) 
     {
       global $ce_showdraft;

       if(!empty($path))
         {
           ce_debug(50,"\n<!-- created item for path $path -->",
                    __FILE__,__LINE__);
           $this->layout_class = $layout_class;
           if( NULL == $state )
             { 
               if($ce_showdraft)
                 $state="DRAFT,OK";
               else
                 $state="OK"; 
             }
           $query = "SELECT id,author,layout_path,name,data,content_type,"
             ."path,locale,abstract,type,state,"
             ."UNIX_TIMESTAMP(date_created) as date_created,"
             ."UNIX_TIMESTAMP(date_modified) as date_modified"
             ." FROM ce_items WHERE path = '".addslashes($path)."' AND state IN ('".preg_replace( "/,/" , "','" , addslashes($state) )
             ."') ORDER BY date_modified DESC";
           ce_debug(50,"\n".'<!-- new item query: "'.$query.'" -->',
                    __FILE__,__LINE__);
           $this->mysql_result = ce_sql_query($query,__FILE__,__LINE__) or die("$query - failed in ce_item():<br>\n".mysql_error()." [".mysql_errno()."]");
           if( ! $this->mysql_fetch() )
             {
               ce_error('Document "'.$path.'" in ce_item() not found!'."<br>\n");
               return NULL;
             }
         }
     }

   function retrieve($id)
     {
       if(!isset($id)) return FALSE;
       $query = "SELECT state,path,layout_path,author,"
         ."UNIX_TIMESTAMP(date_created) as date_created,"
         ."UNIX_TIMESTAMP(date_modified) as date_modified,name,author,data,"
         ."content_type,locale,abstract,type "
         ." FROM ce_items WHERE id = '".addslashes($id)."'";
       ce_debug(6,"\n<!-- ce_edit->retrieve(): $query -->\n",
                            __FILE__,__LINE__);
       $mysql_result = ce_sql_query($query,__FILE__,__LINE__) or die("$query - Failed (ce_item->retrieve(".$id.") in ce_classes.inc):<br>\n".mysql_error()." [".mysql_errno()."]");
       if($mysql_row = mysql_fetch_array($mysql_result))
         {
           $this->state         = $mysql_row["state"];
           $this->path          = $mysql_row["path"];
           $this->layout_path   = $mysql_row["layout_path"];
           $this->locale        = $mysql_row["locale"];
           $this->name          = $mysql_row["name"];
           $this->author        = $mysql_row["author"];
           $this->abstract      = $mysql_row["abstract"];
           $this->content_type  = $mysql_row["content_type"];
           $this->data          = $mysql_row["data"];
           $this->date_created  = $mysql_row["date_created"];
           $this->date_modified = $mysql_row["date_modified"];
           return TRUE;
         }
       else
         return FALSE;
     }

   function add()
     {
       if( isset($this->id) )
         {
           $copy_id=$this->copy();
           $this->id=$copy_id;
           return $this->save();
         }

       $this->delete_other("OK");
       $query="INSERT INTO ce_items SET date_created=now()";
       if( isset( $this->path        ) )
         $query.=", path         = '".addslashes($this->path)."'"        ;
       if( isset( $this->layout_path ) )
         $query.=", layout_path  = '".addslashes($this->layout_path)."'" ;
       if( isset( $this->locale      ) )
         $query.=", locale       = '".addslashes($this->locale)."'"      ;
       if( isset( $this->name        ) )
         $query.=", name         = '".addslashes($this->name)."'"        ;
       if( isset( $this->author      ) )
         $query.=", author       = '".addslashes($this->author)."'"      ;
       if( isset( $this->abstract    ) )
         $query.=", abstract     = '".addslashes($this->abstract)."'"    ;
       if( isset( $this->content_type) ) 
         $query.=", content_type = '".addslashes($this->content_type)."'";
       if( isset( $this->data        ) )
         $query.=", data         = '".addslashes($this->data)."'"        ;
       if( isset( $this->state       ) )
         $query.=", state        = '".addslashes($this->state)."'"       ;

      ce_sql_query($query,__FILE__,__LINE__);
      if(mysql_affected_rows() == 0) 
        {
          print("\n<br><strong>MySQL Error:".mysql_error()."</strong>");
          return FALSE;
        }
      else
        {
          $lastid_array = ce_sql_query("SELECT LAST_INSERT_ID() AS ce_edit_id;",__FILE__,__LINE__);
          $ce_data = mysql_fetch_array($lastid_array);
          $this->id=$ce_data["ce_edit_id"];
          return TRUE;
        }
     }

   function delete_other($state)
     {
       if( $this->state != $state ) return TRUE;
       if ( empty($this->id) )
         {
           ce_error("ce_item-%gt;delete_other() called with empty ce_item-&gt;id");
           return FALSE;
         }
       $query="UPDATE ce_items SET state = 'DEL' where"
         ." path   = '".addslashes($this->path   )."' AND"
         ." locale = '".addslashes($this->locale )."' AND"
         ." state  = '".addslashes($this->state  )."' AND"
         ." id    <> " .addslashes($this->id     );

       ce_debug(50,"\n".'<!-- Query "'.$query.'" in delete_other() -->',
                __FILE__,__LINE__);

       if( ce_sql_query($query,__FILE__,__LINE__) )
         {
           return TRUE;
         }
       else
         {
           ce_error("Query ".$query." failed in ce_item-&gt;delete_other(): "
                    .mysql_error()." [".mysql_errno()."]",NULL,__FILE__,__LINE__);
           return FALSE;
         }
     }

   function save()
     {
       $sep="";
       $query="UPDATE ce_items SET";
       if( isset( $this->path        ) )
         {$query.=$sep." path         = '".addslashes($this->path)."'"        ;$sep=",";}
       if( isset( $this->layout_path ) )
         {$query.=$sep." layout_path  = '".addslashes($this->layout_path)."'" ;$sep=",";}
       if( isset( $this->locale      ) )
         {$query.=$sep." locale       = '".addslashes($this->locale)."'"      ;$sep=",";}
       if( isset( $this->name        ) )
         {$query.=$sep." name         = '".addslashes($this->name)."'"        ;$sep=",";}
       if( isset( $this->author      ) )
         {$query.=$sep." author       = '".addslashes($this->author)."'"      ;$sep=",";}
       if( isset( $this->abstract    ) )
         {$query.=$sep." abstract     = '".addslashes($this->abstract)."'"    ;$sep=",";}
       if( isset( $this->content_type) )
         {$query.=$sep." content_type = '".addslashes($this->content_type)."'";$sep=",";}
       if( isset( $this->data        ) )
         {$query.=$sep." data         = '".addslashes($this->data)."'"        ;$sep=",";}
       if( isset( $this->state       ) )
         {$query.=$sep." state        = '".addslashes($this->state)."'"       ;$sep=",";}
#       else
#         {$query.=$sep." state        = 'OK'"                     ;$sep=",";}
       $query.=" WHERE id=".addslashes($this->id);
       # print "\n<!-- edit.php: $query -->\n";
       if( ce_sql_query($query,__FILE__,__LINE__) )
         {
           $this->retrieve($this->id);
           $this->delete_other("OK");
           return TRUE;
         }
       else
         {
           ce_error("Query ".$query." failed in ce_item-&gt;save()",NULL,__FILE__,__LINE__);
           return FALSE;
         }
     }

   function copy()
   {
     $copy_i =& new ce_item();
     $copy_i->retrieve($this->id);
     if( ! $copy_i->add() )
       {
         ce_error("ce_item-&gt;add() failed in ce_item-&gt;copy()");
         return FALSE;
       }
     return $copy_i->id;
   }

   function copy_and_delete()
   {
     if( ! $copy_id=$this->copy() )
       {
         ce_error("ce_item-&gt;copy() failed in ce_item-&gt;copy_and_delete()");
         return FALSE;
       }
     $query="UPDATE ce_items SET state = 'DEL' where id = '".addslashes($this->id)."';";
     ce_sql_query($query,__FILE__,__LINE__);
     if(mysql_affected_rows() == 0) 
       {
         ce_error("\n<br><strong>MySQL Error:".mysql_error()."</strong>");
         ce_error("\n<br>($query)<br>\n");
         return FALSE;
       }
     $this->id=$copy_id;
     return TRUE;
   }
}

class ce_list_item extends ce_item
{
  function ce_list_item($path=NULL,$layout_class="",$state=NULL,$sort_by=array("date_modified" => "DESC")) 
  {
    global $ce_showdraft;

    if(!empty($path))
      {
        if( NULL === $state )
          { 
            if($ce_showdraft)
              $state="DRAFT,OK";
            else
              $state="OK"; 
          }

        ce_debug(50,"\n<!-- created item for path $path -->",
                 __FILE__,__LINE__);
        $this->layout_class = $layout_class;
        $query = "SELECT id,author,layout_path,name,data,content_type,"
          ."path,locale,abstract,type,state,"
          ."UNIX_TIMESTAMP(date_created) as date_created,"
          ."UNIX_TIMESTAMP(date_modified) as date_modified"
          ." FROM ce_items WHERE path LIKE '".addslashes($path)."' ";
        if( ! empty($state) )
          $query .= "AND state IN ('".preg_replace( "/,/" , "','" , $state )."')";

        $sort_sep=" ORDER BY ";
        while( list($sort_col,$sort_ord)=each($sort_by) )
          {
            $query = $query.$sort_sep.$sort_col." ".$sort_ord;
            $sort_sep=",";
          }
        ce_debug(50,"\n".'<!-- new list item query: "'.$query.'" -->',
                 __FILE__,__LINE__);
        $this->mysql_result = ce_sql_query($query,__FILE__,__LINE__) or die("$query - failed in ce_list_item():<br>\n".mysql_error()." [".mysql_errno()."]");
        if( 0 < mysql_num_rows($this->mysql_result) )
          return TRUE;
        else
          {
            ce_error('No document matching "'.$path.'" in ce_list_item() found!');
            return FALSE;
          }
      }
    else
      {
        ce_error('ce_list_item() called with empty $path in ce_list_item()!');
        $this->mysql_result=FALSE;
        return FALSE;
      }
  }

  function &next()
    {
      unset($this->display_item_no);
      ce_debug(50,
               "\n<!-- get next item after ".$this->id.",".$this->name.",".$this->path." -->",
               __FILE__,__LINE__);
      if($this->mysql_fetch())
        {
          ce_debug(50,
                   "\n<!--           next item:".$this->id.",".$this->name.",".$next->path." -->",
                   __FILE__,__LINE__);
          return true ;
        }
      else
        {
          ce_debug(50,"\n<!-- found no next item  -->",__FILE__,__LINE__);
          return false;
        }
    }
}
